Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Converters/TreeSimplifier.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Converters/TreeSimplifier.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Converters/TreeSimplifier.cs	(revision 18132)
@@ -1320,18 +1320,18 @@
         return a;
       } else if (IsAbsolute(a) && IsAbsolute(b)) {
-        return MakeAbs(MakeProduct(a.GetSubtree(0), b.GetSubtree(0)));
-      } else if (IsAbsolute(a) && IsConstant(b)) {
-        var constNode = b as ConstantTreeNode;
-        var posF = Math.Abs(constNode.Value);
-        if (constNode.Value > 0) {
-          return MakeAbs(MakeProduct(a.GetSubtree(0), MakeConstant(posF)));
+        return Abs(Product(a.GetSubtree(0), b.GetSubtree(0)));
+      } else if (IsAbsolute(a) && IsNumber(b)) {
+        var bNode = b as NumberTreeNode;
+        var posF = Math.Abs(bNode.Value);
+        if (bNode.Value > 0) {
+          return Abs(Product(a.GetSubtree(0), Number(posF)));
         } else {
           var mul = mulSymbol.CreateTreeNode();
-          mul.AddSubtree(MakeAbs(MakeProduct(a.GetSubtree(0), MakeConstant(posF))));
-          mul.AddSubtree(MakeConstant(-1.0));
+          mul.AddSubtree(Abs(Product(a.GetSubtree(0), Number(posF))));
+          mul.AddSubtree(Number(-1.0));
           return mul;
         }
       } else if (IsAnalyticalQuotient(a)) {
-        return MakeAnalyticalQuotient(MakeProduct(a.GetSubtree(0), b), a.GetSubtree(1));
+        return AQ(Product(a.GetSubtree(0), b), a.GetSubtree(1));
       } else {
         var mul = mulSymbol.CreateTreeNode();
@@ -1355,15 +1355,12 @@
 
     private static ISymbolicExpressionTreeNode AddLagToDynamicNodes(ISymbolicExpressionTreeNode node, int lag) {
-      var laggedTreeNode = node as ILaggedTreeNode;
-      var variableNode = node as VariableTreeNode;
-      var variableConditionNode = node as VariableConditionTreeNode;
-      if (laggedTreeNode != null)
+      if (node is ILaggedTreeNode laggedTreeNode)
         laggedTreeNode.Lag += lag;
-      else if (variableNode != null) {
+      else if (node is VariableTreeNode variableNode) {
         var laggedVariableNode = (LaggedVariableTreeNode)laggedVariableSymbol.CreateTreeNode();
         laggedVariableNode.Lag = lag;
         laggedVariableNode.VariableName = variableNode.VariableName;
         return laggedVariableNode;
-      } else if (variableConditionNode != null) {
+      } else if (node is VariableConditionTreeNode) {
         throw new NotSupportedException("Removal of time lags around variable condition symbols is not allowed.");
       }
@@ -1389,13 +1386,13 @@
                             orderby g.Count()
                             select g;
-      var constantProduct = (from node in subtrees.OfType<VariableTreeNodeBase>()
-                             select node.Weight)
-        .Concat(from node in subtrees.OfType<ConstantTreeNode>()
-                select node.Value)
-        .DefaultIfEmpty(1.0)
-        .Aggregate((c1, c2) => c1 * c2);
+      var numberProduct = (from node in subtrees.OfType<VariableTreeNodeBase>()
+                           select node.Weight)
+                          .Concat(from node in subtrees.OfType<NumberTreeNode>()
+                                  select node.Value)
+                          .DefaultIfEmpty(1.0)
+                          .Aggregate((c1, c2) => c1 * c2);
 
       var unchangedSubtrees = from tree in subtrees
-                              where tree.SubtreeCount > 0 || !(tree is IVariableTreeNode) && !(tree is ConstantTreeNode)
+                              where tree.SubtreeCount > 0 || !(tree is IVariableTreeNode) && !(tree is NumberTreeNode)
                               select tree;
 
@@ -1422,7 +1419,7 @@
           }
           for (int j = 0; j < representative.Weights.Length; j++) {
-            representative.Weights[j] *= constantProduct;
+            representative.Weights[j] *= numberProduct;
           }
-          constantProduct = 1.0;
+          numberProduct = 1.0;
           // if the product already contains a factor it is not necessary to multiply a constant below
           prod.AddSubtree(representative);
@@ -1433,6 +1430,6 @@
         prod.AddSubtree(unchangedSubtree);
 
-      if (constantProduct != 1.0) {
-        prod.AddSubtree(MakeConstant(constantProduct));
+      if (numberProduct != 1.0) {
+        prod.AddSubtree(Number(numberProduct));
       }
     }
@@ -1446,6 +1443,6 @@
     /// <returns>-x</returns>
     private static ISymbolicExpressionTreeNode Negate(ISymbolicExpressionTreeNode x) {
-      if (IsConstant(x)) {
-        ((ConstantTreeNode)x).Value *= -1;
+      if (IsNumber(x)) {
+        ((NumberTreeNode)x).Value *= -1;
       } else if (IsVariableBase(x)) {
         var variableTree = (VariableTreeNodeBase)x;
@@ -1471,5 +1468,5 @@
       } else {
         // any other function
-        return MakeProduct(x, MakeConstant(-1));
+        return Product(x, Number(-1));
       }
       return x;
@@ -1483,24 +1480,24 @@
     /// <returns></returns>
     private static ISymbolicExpressionTreeNode Invert(ISymbolicExpressionTreeNode x) {
-      if (IsConstant(x)) {
-        return MakeConstant(1.0 / ((ConstantTreeNode)x).Value);
+      if (IsNumber(x)) {
+        return Number(1.0 / ((NumberTreeNode)x).Value);
       } else if (IsFactor(x)) {
         var factorNode = (FactorVariableTreeNode)x;
-        return MakeFactor(factorNode.Symbol, factorNode.VariableName, factorNode.Weights.Select(w => 1.0 / w));
+        return Factor(factorNode.Symbol, factorNode.VariableName, factorNode.Weights.Select(w => 1.0 / w));
       } else if (IsDivision(x)) {
-        return MakeFraction(x.GetSubtree(1), x.GetSubtree(0));
+        return Fraction(x.GetSubtree(1), x.GetSubtree(0));
       } else {
         // any other function
-        return MakeFraction(MakeConstant(1), x);
-      }
-    }
-
-    private static ISymbolicExpressionTreeNode MakeConstant(double value) {
-      ConstantTreeNode constantTreeNode = (ConstantTreeNode)(constSymbol.CreateTreeNode());
-      constantTreeNode.Value = value;
-      return constantTreeNode;
-    }
-
-    private static ISymbolicExpressionTreeNode MakeFactor(FactorVariable sy, string variableName, IEnumerable<double> weights) {
+        return Fraction(Number(1), x);
+      }
+    }
+
+    private static ISymbolicExpressionTreeNode Number(double value) {
+      var numberTreeNode = (NumberTreeNode)numberSymbol.CreateTreeNode();
+      numberTreeNode.Value = value;
+      return numberTreeNode;
+    }
+
+    private static ISymbolicExpressionTreeNode Factor(FactorVariable sy, string variableName, IEnumerable<double> weights) {
       var tree = (FactorVariableTreeNode)sy.CreateTreeNode();
       tree.VariableName = variableName;
@@ -1508,5 +1505,5 @@
       return tree;
     }
-    private static ISymbolicExpressionTreeNode MakeBinFactor(BinaryFactorVariable sy, string variableName, string variableValue, double weight) {
+    private static ISymbolicExpressionTreeNode BinFactor(BinaryFactorVariable sy, string variableName, string variableValue, double weight) {
       var tree = (BinaryFactorVariableTreeNode)sy.CreateTreeNode();
       tree.VariableName = variableName;
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Converters/TreeToAutoDiffTermConverter.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Converters/TreeToAutoDiffTermConverter.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Converters/TreeToAutoDiffTermConverter.cs	(revision 18132)
@@ -102,5 +102,5 @@
 
     public static bool TryConvertToAutoDiff(ISymbolicExpressionTree tree, bool makeVariableWeightsVariable, bool addLinearScalingTerms,
-      out List<DataForVariable> parameters, out double[] initialConstants,
+      out List<DataForVariable> parameters, out double[] initialParamValues,
       out ParametricFunction func,
       out ParametricFunctionGradient func_grad) {
@@ -115,5 +115,5 @@
           parameterEntries.Select(kvp => kvp.Value).ToArray());
         parameters = new List<DataForVariable>(parameterEntries.Select(kvp => kvp.Key));
-        initialConstants = transformator.initialConstants.ToArray();
+        initialParamValues = transformator.initialParamValues.ToArray();
         func = (vars, @params) => compiledTerm.Evaluate(vars, @params);
         func_grad = (vars, @params) => compiledTerm.Differentiate(vars, @params);
@@ -123,5 +123,5 @@
         func_grad = null;
         parameters = null;
-        initialConstants = null;
+        initialParamValues = null;
       }
       return false;
@@ -129,6 +129,5 @@
 
     // state for recursive transformation of trees 
-    private readonly
-    List<double> initialConstants;
+    private readonly List<double> initialParamValues;
     private readonly Dictionary<DataForVariable, AutoDiff.Variable> parameters;
     private readonly List<AutoDiff.Variable> variables;
@@ -139,5 +138,5 @@
       this.makeVariableWeightsVariable = makeVariableWeightsVariable;
       this.addLinearScalingTerms = addLinearScalingTerms;
-      this.initialConstants = new List<double>();
+      this.initialParamValues = new List<double>();
       this.parameters = new Dictionary<DataForVariable, AutoDiff.Variable>();
       this.variables = new List<AutoDiff.Variable>();
@@ -145,9 +144,13 @@
 
     private AutoDiff.Term ConvertToAutoDiff(ISymbolicExpressionTreeNode node) {
-      if (node.Symbol is Constant) {
-        initialConstants.Add(((ConstantTreeNode)node).Value);
+      if (node.Symbol is Number) {
+        initialParamValues.Add(((NumberTreeNode)node).Value);
         var var = new AutoDiff.Variable();
         variables.Add(var);
         return var;
+      }
+      if (node.Symbol is Constant) {
+        // constants are fixed in autodiff
+        return (node as ConstantTreeNode).Value;
       }
       if (node.Symbol is Variable || node.Symbol is BinaryFactorVariable) {
@@ -159,5 +162,5 @@
 
         if (makeVariableWeightsVariable) {
-          initialConstants.Add(varNode.Weight);
+          initialParamValues.Add(varNode.Weight);
           var w = new AutoDiff.Variable();
           variables.Add(w);
@@ -173,5 +176,5 @@
           var par = FindOrCreateParameter(parameters, factorVarNode.VariableName, variableValue);
 
-          initialConstants.Add(factorVarNode.GetValue(variableValue));
+          initialParamValues.Add(factorVarNode.GetValue(variableValue));
           var wVar = new AutoDiff.Variable();
           variables.Add(wVar);
@@ -186,5 +189,5 @@
 
         if (makeVariableWeightsVariable) {
-          initialConstants.Add(varNode.Weight);
+          initialParamValues.Add(varNode.Weight);
           var w = new AutoDiff.Variable();
           variables.Add(w);
@@ -260,7 +263,7 @@
       }
       if (node.Symbol is Power) {
-        var powerNode = node.GetSubtree(1) as ConstantTreeNode;
+        var powerNode = node.GetSubtree(1) as INumericTreeNode;
         if (powerNode == null)
-          throw new NotSupportedException("Only integer powers are allowed in parameter optimization. Try to use exp() and log() instead of the power symbol.");
+          throw new NotSupportedException("Only numeric powers are allowed in parameter optimization. Try to use exp() and log() instead of the power symbol.");
         var intPower = Math.Truncate(powerNode.Value);
         if (intPower != powerNode.Value)
@@ -313,6 +316,5 @@
       var data = new DataForVariable(varName, varValue, lag);
 
-      AutoDiff.Variable par = null;
-      if (!parameters.TryGetValue(data, out par)) {
+      if (!parameters.TryGetValue(data, out AutoDiff.Variable par)) {
         // not found -> create new parameter and entries in names and values lists
         par = new AutoDiff.Variable();
@@ -330,4 +332,5 @@
           !(n.Symbol is FactorVariable) &&
           !(n.Symbol is LaggedVariable) &&
+          !(n.Symbol is Number) &&
           !(n.Symbol is Constant) &&
           !(n.Symbol is Addition) &&
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/InfixExpressionFormatter.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/InfixExpressionFormatter.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/InfixExpressionFormatter.cs	(revision 18132)
@@ -33,5 +33,5 @@
   public static class BaseInfixExpressionFormatter {
     public static void FormatRecursively(ISymbolicExpressionTreeNode node, StringBuilder strBuilder,
-                                          NumberFormatInfo numberFormat, string formatString, List<KeyValuePair<string, double>> constants = null) {
+                                          NumberFormatInfo numberFormat, string formatString, List<KeyValuePair<string, double>> parameters = null) {
       if (node.SubtreeCount > 1) {
         var token = GetToken(node.Symbol);
@@ -40,9 +40,9 @@
             token == "*" || token == "/" || token == "AND") {
           strBuilder.Append("(");
-          FormatRecursively(node.Subtrees.First(), strBuilder, numberFormat, formatString, constants);
+          FormatRecursively(node.Subtrees.First(), strBuilder, numberFormat, formatString, parameters);
 
           foreach (var subtree in node.Subtrees.Skip(1)) {
             strBuilder.Append(" ").Append(token).Append(" ");
-            FormatRecursively(subtree, strBuilder, numberFormat, formatString, constants);
+            FormatRecursively(subtree, strBuilder, numberFormat, formatString, parameters);
           }
 
@@ -51,12 +51,12 @@
           // handle integer powers directly
           strBuilder.Append("(");
-          FormatRecursively(node.Subtrees.First(), strBuilder, numberFormat, formatString, constants);
+          FormatRecursively(node.Subtrees.First(), strBuilder, numberFormat, formatString, parameters);
 
           var power = node.GetSubtree(1);
-          if(power is ConstantTreeNode constNode && Math.Truncate(constNode.Value) == constNode.Value) {
-            strBuilder.Append(" ").Append(token).Append(" ").Append(constNode.Value.ToString(formatString, numberFormat));
+          if(power is INumericTreeNode numNode && Math.Truncate(numNode.Value) == numNode.Value) {
+            strBuilder.Append(" ").Append(token).Append(" ").Append(numNode.Value.ToString(formatString, numberFormat));
           } else {
             strBuilder.Append(" ").Append(token).Append(" ");
-            FormatRecursively(power, strBuilder, numberFormat, formatString, constants);
+            FormatRecursively(power, strBuilder, numberFormat, formatString, parameters);
           }
 
@@ -65,8 +65,8 @@
           // function with multiple arguments
           strBuilder.Append(token).Append("(");
-          FormatRecursively(node.Subtrees.First(), strBuilder, numberFormat, formatString, constants);
+          FormatRecursively(node.Subtrees.First(), strBuilder, numberFormat, formatString, parameters);
           foreach (var subtree in node.Subtrees.Skip(1)) {
             strBuilder.Append(", ");
-            FormatRecursively(subtree, strBuilder, numberFormat, formatString, constants);
+            FormatRecursively(subtree, strBuilder, numberFormat, formatString, parameters);
           }
 
@@ -77,15 +77,15 @@
         if (token == "-" || token == "NOT") {
           strBuilder.Append("(").Append(token).Append("(");
-          FormatRecursively(node.GetSubtree(0), strBuilder, numberFormat, formatString, constants);
+          FormatRecursively(node.GetSubtree(0), strBuilder, numberFormat, formatString, parameters);
           strBuilder.Append("))");
         } else if (token == "/") {
           strBuilder.Append("1/");
-          FormatRecursively(node.GetSubtree(0), strBuilder, numberFormat, formatString, constants);
+          FormatRecursively(node.GetSubtree(0), strBuilder, numberFormat, formatString, parameters);
         } else if (token == "+" || token == "*") {
-          FormatRecursively(node.GetSubtree(0), strBuilder, numberFormat, formatString, constants);
+          FormatRecursively(node.GetSubtree(0), strBuilder, numberFormat, formatString, parameters);
         } else {
           // function with only one argument
           strBuilder.Append(token).Append("(");
-          FormatRecursively(node.GetSubtree(0), strBuilder, numberFormat, formatString, constants);
+          FormatRecursively(node.GetSubtree(0), strBuilder, numberFormat, formatString, parameters);
           strBuilder.Append(")");
         }
@@ -96,5 +96,5 @@
           if (!varNode.Weight.IsAlmost(1.0)) {
             strBuilder.Append("(");
-            AppendConstant(strBuilder, constants, varNode.Weight, formatString, numberFormat);
+            AppendNumber(strBuilder, parameters, varNode.Weight, formatString, numberFormat);
             strBuilder.Append("*");
           }
@@ -110,5 +110,5 @@
           if (!varNode.Weight.IsAlmost(1.0)) {
             strBuilder.Append("(");
-            AppendConstant(strBuilder, constants, varNode.Weight, formatString, numberFormat);
+            AppendNumber(strBuilder, parameters, varNode.Weight, formatString, numberFormat);
             strBuilder.Append("*");
           }
@@ -124,5 +124,5 @@
           for (int i = 0; i < factorNode.Weights.Length; i++) {
             if (i > 0) strBuilder.Append(", ");
-            AppendConstant(strBuilder, constants, factorNode.Weights[i], formatString, numberFormat);
+            AppendNumber(strBuilder, parameters, factorNode.Weights[i], formatString, numberFormat);
           }
           strBuilder.Append("]");
@@ -131,5 +131,5 @@
           if (!factorNode.Weight.IsAlmost(1.0)) {
             strBuilder.Append("(");
-            AppendConstant(strBuilder, constants, factorNode.Weight, formatString, numberFormat);
+            AppendNumber(strBuilder, parameters, factorNode.Weight, formatString, numberFormat);
 
             strBuilder.Append("*");
@@ -141,11 +141,11 @@
 
           if (!factorNode.Weight.IsAlmost(1.0)) strBuilder.Append(")");
-        } else if (node.Symbol is Constant) {
-          var constNode = node as ConstantTreeNode;
-          if (constants == null && constNode.Value < 0) {
-            strBuilder.Append("(").Append(constNode.Value.ToString(formatString, numberFormat))
-                      .Append(")"); // (-1
+        } else if (node is INumericTreeNode numNode) {
+          if (parameters == null && numNode.Value < 0) {
+            // negative value
+            strBuilder.Append("(").Append(numNode.Value.ToString(formatString, numberFormat))
+                      .Append(")"); 
           } else {
-            AppendConstant(strBuilder, constants, constNode.Value, formatString, numberFormat);
+            AppendNumber(strBuilder, parameters, numNode.Value, formatString, numberFormat);
           }
         }
@@ -153,9 +153,9 @@
     }
 
-    private static void AppendConstant(StringBuilder strBuilder, List<KeyValuePair<string, double>> constants, double value, string formatString, NumberFormatInfo numberFormat) {
-      if (constants != null) {
-        string constantKey = $"c_{constants.Count}";
-        strBuilder.AppendFormat(CultureInfo.InvariantCulture, "{0}", constantKey);
-        constants.Add(new KeyValuePair<string, double>(constantKey, value));
+    private static void AppendNumber(StringBuilder strBuilder, List<KeyValuePair<string, double>> parameters, double value, string formatString, NumberFormatInfo numberFormat) {
+      if (parameters != null) {
+        string paramKey = $"c_{parameters.Count}";
+        strBuilder.AppendFormat(CultureInfo.InvariantCulture, "{0}", paramKey);
+        parameters.Add(new KeyValuePair<string, double>(paramKey, value));
       } else {
         strBuilder.Append(value.ToString(formatString, numberFormat));
@@ -204,6 +204,6 @@
     /// </summary>
     /// <param name="symbolicExpressionTree">The tree representation of the expression.</param>
-    /// <param name="numberFormat">Number format that should be used for numeric parameters (e.g. NumberFormatInfo.InvariantInfo (default)).</param>
-    /// <param name="formatString">The format string for numeric parameters (e.g. \"G4\" to limit to 4 digits, default is \"G\")</param>
+    /// <param name="numberFormat">Number format that should be used for parameters (e.g. NumberFormatInfo.InvariantInfo (default)).</param>
+    /// <param name="formatString">The format string for parameters (e.g. \"G4\" to limit to 4 digits, default is \"G\")</param>
     /// <returns>Infix expression</returns>
     public string Format(ISymbolicExpressionTree symbolicExpressionTree, NumberFormatInfo numberFormat,
@@ -241,15 +241,15 @@
     public string Format(ISymbolicExpressionTree symbolicExpressionTree) {
       StringBuilder strBuilder = new StringBuilder();
-      var constants = new List<KeyValuePair<string, double>>();
+      var parameters = new List<KeyValuePair<string, double>>();
       BaseInfixExpressionFormatter.FormatRecursively(symbolicExpressionTree.Root.GetSubtree(0).GetSubtree(0),
-        strBuilder, NumberFormatInfo.InvariantInfo, "G", constants);
+        strBuilder, NumberFormatInfo.InvariantInfo, "G", parameters);
       strBuilder.Append($"{Environment.NewLine}{Environment.NewLine}");
 
-      int maxDigits = GetDigits(constants.Count);
-      int padding = constants.Max(x => x.Value.ToString("F12", CultureInfo.InvariantCulture).Length);
-      foreach (var constant in constants) {
-        int digits = GetDigits(Int32.Parse(constant.Key.Substring(2)));
-        strBuilder.Append($"{constant.Key}{new String(' ', maxDigits - digits)} = " +
-                          string.Format($"{{0,{padding}:F12}}", constant.Value, CultureInfo.InvariantCulture) +
+      int maxDigits = GetDigits(parameters.Count);
+      int padding = parameters.Max(x => x.Value.ToString("F12", CultureInfo.InvariantCulture).Length);
+      foreach (var param in parameters) {
+        int digits = GetDigits(int.Parse(param.Key.Substring(2)));
+        strBuilder.Append($"{param.Key}{new string(' ', maxDigits - digits)} = " +
+                          string.Format($"{{0,{padding}:F12}}", param.Value, CultureInfo.InvariantCulture) +
                           Environment.NewLine);
       }
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionCSharpFormatter.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionCSharpFormatter.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionCSharpFormatter.cs	(revision 18132)
@@ -162,7 +162,6 @@
           var varNode = node as VariableTreeNode;
           strBuilder.AppendFormat("{0} * {1}", VariableName2Identifier(varNode.VariableName), varNode.Weight.ToString("g17", CultureInfo.InvariantCulture));
-        } else if (node is ConstantTreeNode) {
-          var constNode = node as ConstantTreeNode;
-          strBuilder.Append(constNode.Value.ToString("g17", CultureInfo.InvariantCulture));
+        } else if (node is INumericTreeNode numNode) {
+          strBuilder.Append(numNode.Value.ToString("g17", CultureInfo.InvariantCulture));
         } else if (node.Symbol is FactorVariable) {
           var factorNode = node as FactorVariableTreeNode;
@@ -311,7 +310,7 @@
 
     private void GenerateFactorSource(StringBuilder strBuilder) {
-      strBuilder.AppendLine("private static double EvaluateFactor(string factorValue, string[] factorValues, double[] constants) {");
+      strBuilder.AppendLine("private static double EvaluateFactor(string factorValue, string[] factorValues, double[] parameters) {");
       strBuilder.AppendLine("   for(int i=0;i<factorValues.Length;i++) " +
-                            "      if(factorValues[i] == factorValue) return constants[i];" +
+                            "      if(factorValues[i] == factorValue) return parameters[i];" +
                             "   throw new ArgumentException();");
       strBuilder.AppendLine("}");
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionExcelFormatter.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionExcelFormatter.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionExcelFormatter.cs	(revision 18132)
@@ -47,10 +47,10 @@
     private string GetExcelColumnName(int columnNumber) {
       int dividend = columnNumber;
-      string columnName = String.Empty;
+      string columnName = string.Empty;
 
       while (dividend > 0) {
         int modulo = (dividend - 1) % 26;
         columnName = System.Convert.ToChar(65 + modulo) + columnName;
-        dividend = (int)((dividend - modulo) / 26);
+        dividend = (dividend - modulo) / 26;
       }
 
@@ -134,7 +134,7 @@
         }
         stringBuilder.Append("))");
-      } else if (symbol is Constant) {
-        ConstantTreeNode constantTreeNode = node as ConstantTreeNode;
-        stringBuilder.Append(constantTreeNode.Value.ToString(CultureInfo.InvariantCulture));
+      } else if (symbol is INumericSymbol numSy) {
+        var numTreeNode = node as INumericTreeNode;
+        stringBuilder.Append(numTreeNode.Value.ToString(CultureInfo.InvariantCulture));
       } else if (symbol is Cosine) {
         stringBuilder.Append("COS(");
